package nccloud.web.hrwa.pubinfo.wadataexplain.action;

import nccloud.itf.bd.wadataexplain.IWadataexplainService;
import nc.vo.hrwa.wadataexplain.Wadataexplain;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.logging.Logger;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.vo.bd.meta.BatchOperateVO;
import nccloud.commons.collections.CollectionUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.convert.translate.Translator;
import nccloud.framework.web.ui.pattern.grid.Grid;
import nccloud.framework.web.ui.pattern.grid.GridFormulaHandler;
import nccloud.framework.web.ui.pattern.grid.GridOperator;
import nccloud.vo.utils.BatchVOTool;
import nccloud.web.action.NCCAction;
import nccloud.web.utils.GridModelConvertUtils;

/***************************************************************
 * @author tangcht
 * @version nccloud1.0
 * @since 2018-7-10
 * @see
 ***************************************************************/
public class WadataexplainSaveAction extends NCCAction {

	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		Grid grid = (Grid) para;
		GridModelConvertUtils gridConvUtl = new GridModelConvertUtils();
		Wadataexplain[] vos = gridConvUtl.toVOs(Wadataexplain.class, grid.getModel());
		BatchVOTool<Wadataexplain> tool = new BatchVOTool<Wadataexplain>(Wadataexplain.class);
		BatchOperateVO batchVO = tool.getBatchOperateVO(vos);
		
		//add by longht 校验当前保存vo的期间是否可以保存 start
		StringBuffer pk_wa_class_buf = new StringBuffer();
		StringBuffer cyearperiodbuff = new StringBuffer();
		StringBuffer pk_databuf = new StringBuffer();
		
		
		List<String> cyplist = new ArrayList<String>();
		List<String> waclasslist = new ArrayList<String>();
		List<String> pk_datalist = new ArrayList<String>();
		
		StringBuffer pk_psndoc_buf = new StringBuffer();
		StringBuffer cyp1buf = new StringBuffer();
		StringBuffer pk_cybuf = new StringBuffer();
		StringBuffer drbuf = new StringBuffer();
		StringBuffer pwitembuf = new StringBuffer();
		List<String> cyp1list = new ArrayList<String>();
		List<String> pk_psndoclist = new ArrayList<String>();
		List<String> pkcylist = new ArrayList<String>();
		List<String> drlist = new ArrayList<String>();
		List<String> pwitemlist = new ArrayList<String>();
		//List<String> pnlist = new ArrayList<String>();
		
		Wadataexplain[] addvos = (Wadataexplain[]) batchVO.getAddObjs();
		Wadataexplain[] upvos = (Wadataexplain[]) batchVO.getUpdObjs();
		List<Wadataexplain> batchvos = new ArrayList<Wadataexplain>();
	
		//判断是否是新增或修改过
		if(addvos!=null||upvos!=null) {
			
			if(addvos!=null) {
				
			 for(Wadataexplain vo : addvos) {
				 //String pk_psndoc =vo.getPk_psndoc() ;
				// String cyp1 = vo.getDef1();
				 String pk_cp1 = vo.getPk_psndoc()+vo.getDef1()+vo.getPk_wa_classitem();
				
			if(!pkcylist.contains(pk_cp1)) {
				 
				//if(!pkcylist.contains(pk_psndoc))
				//	pk_psndoc_buf.append("'").append(pk_psndoc).append("',");
				//if(!pkcylist.contains(cyp1))
				//	cyp1buf.append("'").append(cyp1).append("',");	
				
				pk_cybuf.append("'").append(pk_cp1).append("',");
				
				pkcylist.add(pk_cp1);
				batchvos.add(vo);
			}else {
				
			String sql = "select name as "+"姓名"+" from bd_psndoc where pk_psndoc = "+"'"+vo.getPk_psndoc()+"'";
						
				List<Map<String, String>> thiswadataitemList = (List<Map<String, String>>)ServiceLocator.find(IUAPQueryBS.class).executeQuery(sql.toString(), new MapListProcessor());
				ExceptionUtils.wrappBusinessException("新增的数据有重复人员:"+thiswadataitemList);
			}		 
		}
			 

//		StringBuffer psnbyf = new StringBuffer;
//		List<String> pnlist = new ArrayList<String>();
//		for(Wadataexplain vo : addvos) {
//		String pk_cp1 = vo.getPk_psndoc()+vo.getDef1()+vo.getPk_wa_classitem();
//		pkcylist.add(pk_cp1);
//			}
			
//			for(Wadataexplain vo : addvos) {
//				String pk_pn = vo.getPk_psndoc();
//				if(!pnlist.contains(pk_pn))
//				psnbyf.append("'").append(pk_pn).append("',");
//				pnlist.add(pk_pn);
//				
//					}
			
//	for(Wadataexplain vo : addvos) {
//			for(int i=0;i<pkcylist.size();i++){
//				for(int j=i+1;j<pkcylist.size();j++){
//						if(pkcylist.get(i).equals(pkcylist.get(j))){
//
//
//						StringBuffer sqlBufall = new StringBuffer();
//						sqlBufall.append("select name as ");
//						sqlBufall.append("姓名");
//						sqlBufall.append(" from bd_psndoc where pk_psndoc in ( ");
//						
//						sqlBufall.append(psnbyf.substring(0, cyearperiodbuff.length()-1));
//						
//						sqlBufall.append(" ) ");
//
//														
//						List<Map<String, String>> thiswadataitemList = (List<Map<String, String>>)ServiceLocator.find(IUAPQueryBS.class).executeQuery(sqlBufall.toString(), new MapListProcessor());
//						
//						ExceptionUtils.wrappBusinessException("新增的数据有重复人员:"+thiswadataitemList);
//							
//					}else{
//						batchvos.add(vo);
//						}
//										
//					}
//				}
//				batchvos.add(vo);
//			}			 
	
				
	
				
			 		
}
			
			if(upvos!=null) {
				for(Wadataexplain vo : upvos) {
				    String pk_wadata =	vo.getPk_wa_data_explain();
					if(!pk_datalist.contains(pk_wadata))
						pk_databuf.append("'").append(pk_wadata).append("',");
					pk_datalist.add(pk_wadata);
					
					batchvos.add(vo);
				
					}
				}
		
		
		for (Wadataexplain vo : batchvos) {
			String pk_wa_class = vo.getPk_wa_class();
			String cyp = vo.getDef1();
			
			if(!waclasslist.contains(pk_wa_class))
				pk_wa_class_buf.append("'").append(pk_wa_class).append("',");
			if(!cyplist.contains(cyp))
				cyearperiodbuff.append("'").append(cyp).append("',");
			
			cyplist.add(cyp);
			waclasslist.add(pk_wa_class);
		}
		
		//当前会计期间已经 全部审批，不允许保存
		StringBuffer dataBufall = new StringBuffer();
		dataBufall.append(" select pk_wa_data from wa_data");
		dataBufall.append(" where checkflag = 'N'");
		dataBufall.append(" and pk_wa_class in ( ");
		dataBufall.append(pk_wa_class_buf.substring(0, pk_wa_class_buf.length()-1));
		dataBufall.append(" )");
		dataBufall.append(" and cyearperiod in ( ");
		dataBufall.append(cyearperiodbuff.substring(0, cyearperiodbuff.length()-1));
		dataBufall.append(" )");
		dataBufall.append(" and nvl(dr,0)=0");
		
		List<Map<String, Object>> alldatalist = (List<Map<String, Object>>)ServiceLocator.find(IUAPQueryBS.class).executeQuery(dataBufall.toString(), new MapListProcessor());
		if(CollectionUtils.isEmpty(alldatalist))
			ExceptionUtils.wrappBusinessException("薪资发放节点数据已全部审核，不允许保存");
		

	
		
		for (Wadataexplain vo : batchvos) {
			String pk_psndoc = vo.getPk_psndoc();
			String cyp1 = vo.getDef1();
			String dr = vo.getDr().toString();
			String pk_wa_classitem = vo.getPk_wa_classitem();
		if(!pk_psndoclist.contains(pk_psndoc)) {
			pk_psndoc_buf.append("'").append(pk_psndoc).append("',");
			pk_psndoclist.add(pk_psndoc);
		}
		if(!cyp1list.contains(cyp1)) {
			cyp1buf.append("'").append(cyp1).append("',");
			cyp1list.add(cyp1);
		}
		
			if(!drlist.contains(dr)) {
				drbuf.append("'").append(dr).append("',");
				drlist.add(dr);
			}
			
			if(!pwitemlist.contains(pk_wa_classitem)) {
				pwitembuf.append("'").append(pk_wa_classitem).append("',");
				pwitemlist.add(pk_wa_classitem);
			}
		}
		//过滤同一期间条件
		StringBuffer Bufall = new StringBuffer();
		Bufall.append(" select pk_psndoc,def1,dr,pk_wa_data_explain from wa_data_explain where pk_psndoc in(");
		Bufall.append(pk_psndoc_buf.substring(0, pk_psndoc_buf.length()-1));
		Bufall.append(" ) ");
		Bufall.append(" and def1 in (");
		Bufall.append(cyp1buf.substring(0, cyp1buf.length()-1));
		Bufall.append(" ) ");
		
		Bufall.append(" and dr in (");
		Bufall.append(drbuf.substring(0, drbuf.length()-1));
		Bufall.append(" ) ");
		
		Bufall.append(" and pk_wa_classitem in (");
		Bufall.append(pwitembuf.substring(0, pwitembuf.length()-1));
		Bufall.append(" ) ");
		
		if( null!=batchVO.getUpdObjs()) {
			
			Bufall.append(" and pk_wa_data_explain not in (");
			Bufall.append(pk_databuf.substring(0, pk_databuf.length()-1));
			Bufall.append("  )");
			
		}
		List<Map<String, Object>> bill = (List<Map<String, Object>>)ServiceLocator.find(IUAPQueryBS.class).executeQuery(Bufall.toString(), new MapListProcessor());
		if(!CollectionUtils.isEmpty(bill))
			ExceptionUtils.wrappBusinessException("同一期间人员重复");
		}
		
		//add by longht 校验当前保存vo的期间是否可以保存 end 
		BatchOperateVO savedBatchVO = ServiceLocator.find(IWadataexplainService.class).batchSaveCurrtype(batchVO);
		Wadataexplain[] saveVOs = tool.getVOsByBatchVO(savedBatchVO);
		if (saveVOs != null && saveVOs.length > 0) {
			grid = gridConvUtl.toGridOpe(WadataexplainConsts.pagecode, saveVOs);
			 //GridOperator gridOperator = new GridOperator(WadataexplainConsts.pagecode);
			 //grid = gridOperator.toGrid(saveVOs);
			
		}
		
		// 处理显示公式
		GridFormulaHandler gridFormulaHandler = new GridFormulaHandler(grid);
		gridFormulaHandler.handleLoadFormula();
		// 翻译器，将主键翻译成名称
		Translator translator = new Translator();
		translator.translate(grid);
		return grid;
	}

	@Override
	protected Class getParaClass() {
		return Grid.class;
	}

}
